library angular2.src.core.compiler.pipeline.shim_shadow_dom_dart;

import './compile_step.dart' show CompileStep;
import './compile_element.dart' show CompileElement;
import './compile_control.dart' show CompileControl;
import 'package:angular2/src/facade/lang.dart' show isPresent;
import 'package:angular2/src/core/compiler/directive_metadata.dart'
    show DirectiveMetadata;
import 'package:angular2/src/core/compiler/shadow_dom_strategy.dart'
    show ShadowDomStrategy;
import 'package:angular2/src/core/compiler/shadow_dom_emulation/shim_component.dart'
    show ShimComponent;

class ShimShadowDom extends CompileStep {
  ShadowDomStrategy _strategy;
  ShimComponent _shimComponent;
  ShimShadowDom(DirectiveMetadata cmpMetadata, ShadowDomStrategy strategy)
      : super() {
    this._strategy = strategy;
    this._shimComponent = strategy.getShimComponent(cmpMetadata.type);
  }
  process(
      CompileElement parent, CompileElement current, CompileControl control) {
    if (current.ignoreBindings) {
      return;
    }
    this._shimComponent.shimContentElement(current.element);
    var host = current.componentDirective;
    if (isPresent(host)) {
      var shimComponent = this._strategy.getShimComponent(host.type);
      shimComponent.shimHostElement(current.element);
    }
  }
}
