library angular2.src.core.compiler.shadow_dom_emulation.shim_component_dart;

import 'package:angular2/src/facade/dom.dart' show Element, DOM;
import 'package:angular2/src/facade/collection.dart' show Map, MapWrapper;
import 'package:angular2/src/facade/lang.dart' show int, isBlank, Type;
import './shadow_css.dart' show ShadowCss;

class ShimComponent {
  ShimComponent(Type component) {}
  String shimCssText(String cssText) {
    return null;
  }
  shimContentElement(Element element) {}
  shimHostElement(Element element) {}
}
class ShimNativeComponent extends ShimComponent {
  ShimNativeComponent(Type component) : super(component) {}
  String shimCssText(String cssText) {
    return cssText;
  }
  shimContentElement(Element element) {}
  shimHostElement(Element element) {}
}
Map<Type, int> _componentCache = MapWrapper.create();
int _componentId = 0;
resetShimComponentCache() {
  MapWrapper.clear(_componentCache);
  _componentId = 0;
}
class ShimEmulatedComponent extends ShimComponent {
  int _cmpId;
  ShimEmulatedComponent(Type component) : super(component) {
    var componentId = MapWrapper.get(_componentCache, component);
    if (isBlank(componentId)) {
      componentId = _componentId++;
      MapWrapper.set(_componentCache, component, componentId);
    }
    this._cmpId = componentId;
  }
  String shimCssText(String cssText) {
    var shadowCss = new ShadowCss();
    return shadowCss.shimCssText(
        cssText, this._getContentAttribute(), this._getHostAttribute());
  }
  shimContentElement(Element element) {
    DOM.setAttribute(element, this._getContentAttribute(), '');
  }
  shimHostElement(Element element) {
    DOM.setAttribute(element, this._getHostAttribute(), '');
  }
  _getHostAttribute() {
    return '''_nghost-${this._cmpId}''';
  }
  _getContentAttribute() {
    return '''_ngcontent-${this._cmpId}''';
  }
}
